<?php

	include_once( PLOG_CLASS_PATH."class/action/admin/adminaction.class.php" );
	include_once( PLOG_CLASS_PATH."plugins/delicious/class/view/plugindeliciousconfigview.class.php" );	
		
	/**
	 * updates the plugin configuration
	 */
	class PluginDeliciousUpdateConfigAction extends AdminAction
	{
		var $_pluginEnabled;
		var $_userName;
		var $_password;
		
		function PluginDeliciousUpdateConfigAction( $actionInfo, $request )
		{
			$this->AdminAction( $actionInfo, $request );
		}
		
		function validate()
		{
            $this->_pluginEnabled = $this->_request->getValue( "pluginEnabled" );
            $this->_pluginEnabled = ($this->_pluginEnabled != "" );	
            
            $this->_userName = $this->_request->getValue( "userName" );
            if( $this->_userName == "" ) {
                $this->_view = new PluginDeliciousConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("delicious_error_username"));
                $this->setCommonData();

                return false;                
            }  
                           
            $this->_password = $this->_request->getValue( "password" );
            if( $this->_password == "" ) {
                $this->_view = new PluginDeliciousConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("delicious_error_password"));
                $this->setCommonData();

                return false;                   
            }
        
			return true;
		}
		        
		function perform()
		{
            // update the plugin configurations to blog setting
			$blogSettings = $this->_blogInfo->getSettings();
            $blogSettings->setValue( "plugin_delicious_enabled", $this->_pluginEnabled );
            $blogSettings->setValue( "plugin_delicious_username", $this->_userName );
            $blogSettings->setValue( "plugin_delicious_password", $this->_password );
            $this->_blogInfo->setSettings( $blogSettings ); 
		
			// save the blogs settings
			$blogs = new Blogs();
            if( !$blogs->updateBlog( $this->_blogInfo )) {
                $this->_view = new PluginDeliciousConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("error_updating_settings"));
                $this->setCommonData();

                return false;                
            }
			
			// if everything went ok...
            $this->_blogInfo->setSettings( $blogSettings );
            $this->_session->setValue( "blogInfo", $this->_blogInfo );
            $this->saveSession();

			$this->_view = new PluginDeliciousConfigView( $this->_blogInfo );
			$this->_view->setSuccessMessage( $this->_locale->tr("delicious_settings_saved_ok"));
			$this->setCommonData();

			// clear the cache
			CacheControl::resetBlogCache( $this->_blogInfo->getId());				
            
            return true;		
		}
	}
?>